
/*

Draw Omnicalc Font on GdkDrawable.

GdkDrawable *drawable - GdkWindow or GdkPixmap
GdkColor *fgcolor - foreground color
const unsigned char *fontdata - a array generated by "8xf2c".
int x - X coordinate
int y - Y coordinate
int amp - amplitude
const char *string - string

*/

void gdk_draw_string_by_tifont(GdkDrawable *drawable, GdkColor *fgcolor,
                          const unsigned char *fontdata, int x, int y, int amp, const char *string)
{
  int i, j, k;
  GdkGC *gc = gdk_gc_new(drawable);

  gdk_colormap_alloc_color(gdk_colormap_get_system(), fgcolor, TRUE, TRUE);
  gdk_gc_set_foreground(gc, fgcolor);

    for(i=0; i<strlen(string); i++)
    {
      int c = string[i];
        for(j=0; j<7; j++)
        {
          unsigned char d = fontdata[c*7 + j];
            for(k=0; k<5; k++)
            {
                if((d&0x10) != 0)
                {
                  gdk_draw_rectangle(drawable, gc, TRUE, x+i*6*amp+k*amp, y+j*amp, amp, amp);
                }
              d <<= 1;
            }
        }
    }

  gdk_gc_unref(gc);
}

